org 8000h
ljmp START
org 8100h

; KONSTANTY:
;
; cisla
;
char_0      equ 3fh
char_1      equ 06h
char_2      equ 5bh
char_3      equ 4fh
char_4      equ 66h
char_5      equ 6dh
char_6      equ 7dh
char_7      equ 07h
char_8      equ 7fh
char_9      equ 6fh 
;
; pismena
;
char_A      equ 77h
char_B      equ 7ch
char_C      equ 39h
char_D      equ 5eh
char_E      equ 79h
char_F      equ 71h
char_H      equ 76h
char_J      equ 1Fh
char_L      equ 38h
char_n      equ 54h
char_o      equ 5ch
char_P      equ 63h
char_r      equ 50h
char_S      equ 6dh
char_u      equ 1ch
char_Y      equ 6eh
;
; specialni znaky
;
char_blank  equ 00h	
char_minus  equ 40h
;
;
; 
; Podprogramy:
;
; DISP_INIT a DISP_CLEAR
;
disp_init:  clr  P1.0
            clr  P1.1
            mov  a,#36
disp_i1:    clr  P1.0
            setb P1.0
            djnz ACC,disp_i1
disp_clear: setb P1.1
            clr  P1.0
            setb P1.0
            clr  P1.1
            mov  a,#35
disp_i2:    clr  P1.0
            setb P1.0             
            djnz ACC,disp_i2
            ret
;
;
; DISP_SHOW
;           
disp_show: setb P1.1
           clr  P1.0
           setb P1.0
           mov  R0,#1
           lcall disp_blank
           mov R0, #7
           mov  a, R3
           rlc  a
           mov R0, #7
           lcall disp_data
           mov  R0,#3
           lcall disp_blank
           mov  R0, #4
           mov  a, R2
           rlc  a
           lcall disp_data
           mov  R0, #4
           lcall disp_blank
           mov  R0, #3
           lcall disp_data
           mov  R0, #3
           mov  a, R1
           rlc  a
           lcall disp_data
           mov  R0, #1
           lcall disp_blank
           mov  R0, #1
           lcall disp_data
           mov  R0, #2
           lcall disp_blank
           mov  R0, #3
           lcall disp_data
           mov  R0, #3
           lcall disp_blank
           ret
;
;
; Pomocne podprogramy
;
; DISP_DATA
;
; A - data; R0 - pocet vysilanych bitu
;
disp_data: rlc  a
           mov  P1.1, c
           clr  P1.0
           setb P1.0
           djnz R0, disp_data
           ret
;
; DISP_BLANK
;
; R0 - delka
;
disp_blank: clr  P1.1                                                         
disp_b1:    clr  P1.0
            setb P1.0
            djnz R0, disp_b1
            ret
;            
;
Tabulka:    db char_0, char_1, char_2, char_3, char_4
            db char_5, char_6, char_7, char_8, char_9
            db char_A, char_B, char_C, char_D, char_E
            db char_F, char_blank
;


show_num:   
         mov dptr,#tabulka
         mov a,r3
         movc a,@a+dptr
         mov r3,a

         mov a,r2
         movc a,@a+dptr
         mov r2,a

         mov a,r1
         movc a,@a+dptr
         mov r1,a

         ljmp disp_show

show_acc:
         mov b,#10
         div ab
         mov R1,b
         jz blank2
 
         mov b,#10
         div ab
         mov R2,b
         jz blank1
         mov R3,a
         ljmp show_num
         
blank2:  mov R2,#16
blank1:  mov r3,#16
         ljmp show_num
         

START:   

         lcall  disp_init
         
;         mov r3,#char_0
;         mov r2,#char_5
;         mov r1,#char_9
 
         mov a, #5
         lcall show_acc

;         lcall disp_show

konec:     jmp  konec        
         END
