; Demonstracni aplikace pro RT jadro ve verzi 1.2Y (RTA2.ASM)
; Jadro prelozeno od 9800H
; 3 procesy

; ---------------------------------------------------------------------------


cold_start	equ	9800h

rt_create	equ	983dh
rt_kill  	equ	9894h
rt_delay	equ	98bah
rt_init_sig	equ	98d7h
rt_wait_sig	equ	9902h
rt_send_sig	equ	994ch
rt_set_slice	equ	9982h

timer0_int	equ	9985h



; ---------------------------------------------------------------------------

ACT data 60h
TEST data 61h

DSEG
		org	08h

value:		ds	1
key:		ds	1



; ---------------------------------------------------------------------------

CSEG
 		org     8000h
 		clr     EA
 		jmp     cold_start

; ---------------------------------------------------------------------------

; ULOHA 0
org 8050h
	Tab:    db 0, 1, 2, 0, 3, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0

		org	8100h

; uloha 0 inicializuje - vytvori a spusti dalsi procesy, vytvori a 
; inicializuje signaly atd.
		
main:		lcall   disp_init
                mov	r7, #10		; telo procesu 0
		lcall	rt_set_slice	; prepinani kontextu po 10 ms

		mov	r4, #HIGH keys
		mov	r5, #LOW  keys
		mov	r7, #1
		lcall	rt_create	; vytvoreni ulohy - obsluha
					; tlacitek

		mov	r4, #HIGH led
		mov	r5, #LOW  led
		mov	r7,#2
		lcall	rt_create	; vytvoreni ulohy - blikac LED

		mov	r5, #0
		mov	r7, #0
		lcall	rt_init_sig	; inicializace signalu 0
					; = bylo stisknuto tlacitko

		mov	r5, #1
		mov	r7, #1
		lcall	rt_init_sig	; inicializace signalu 1
					; = tlacitko odebrano

		mov	value, #0	; cislo na displeji
					; pocatecni nastaveni
		
		mov	dpl, value	; vypiseme
		mov     dph, #0
		lcall	disp_hex

; -------

; hlavni smycka ulohy 0
; - aktualizace hodnoty citace a jeho zobrazeni na displeji

mov r0, #10h
task0_loop:				; hlavni smycka ulohy 0

	  ;inc TEST
		;mov dpl, TEST
		;mov dph,#0
		
		;lcall disp_hex
					
		;mov r7,#255
;		lcall rt_delay			
		
		ljmp	task0_loop
ret	

; ---------------------------------------------------------------------------

; ULOHA 1 - sejmuti tlacitek

keys:   	mov	key, #0         ; inicializace
					
task1_loop:	

		lcall tl2
		
		mov dpl, a
		mov dph,#0
		
		lcall disp_dec

	 
	 ljmp	task1_loop      ; a znovu !


; ---------------------------------------------------------------------------

; ULOHA 2 - Blikac

led:
task2_loop:  
		ljmp	task2_loop

; ---------------------------------------------------------------------------

tlacitka:
	clr p1.6
	setb p1.7
	mov a, P1
	anl a, #30h
	rr a
	rr a
	mov R0, a
	clr P1.7
	setb P1.6
	mov a, P1
	anl a, #30h
	orl a, R0
	rr a
	rr a
	xrl a,#0ffh
	anl a, #0Fh
ret

tl2:
	lcall tlacitka
	mov dptr,#Tab
  movc a,@a+dptr
ret

wait_zakmit:
	mov r7, #10
	lcall rt_dela
ret

raw_tl:
	lcall tl2
	mov TEST, a
	lcall wait_zakmit
	lcall tl2
	cjne a,TEST, nie_zmena
	mov ACT, a
nie_zmena:
	ret
	
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

$include (disp.asm)

		end